OpenShot Audio Library | OpenShotAudio: juce::ChildProcessManager Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0 |

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::ChildProcessManager Class Referencefinal

`#include <juce_ChildProcessManager.h>`

Inheritance diagram for juce::ChildProcessManager:

## Public Member Functions
template<typename... Args>
std::shared_ptr< ChildProcess > | createAndStartManagedChildProcess (Args &&... args)
auto | addChildProcessExitedListener (std::function< void(ChildProcess *)> listener)
auto | hasRunningProcess () const

## Detailed Description

Manages a set of ChildProcesses and periodically checks their return value. Upon completion it calls listeners added with addChildProcessExitedListener().

This class is mostly aimed for usage on Linux, where terminated child processes are only cleaned up if their return code is read after termination. In order to ensure this one needs to call ChildProcess::isFinished() until it returns false or ChildProcess::waitForProcessToFinish() until it returns true.

This class will keep querying the return code on a Timer thread until the process terminates. This can be handy if one wants to start and stop multiple ChildProcesses on Linux that could take a long time to complete.

Since this class uses a Timer to check subprocess status, it's generally only safe to access the returned ChildProcesses from the message thread.

See also
  ChildProcessManagerSingleton

Definition at line 47 of file juce_ChildProcessManager.h.

## Member Function Documentation

## ◆ addChildProcessExitedListener()

auto juce::ChildProcessManager::addChildProcessExitedListener | ( | std::function< void(ChildProcess *)> | listener | ) |
| inline

Registers a callback function that is called for every ChildProcess that terminated.

This registration is deleted when the returned ErasedScopedGuard is deleted.

Definition at line 80 of file juce_ChildProcessManager.h.

## ◆ createAndStartManagedChildProcess()

template<typename... Args>

std::shared_ptr< ChildProcess > juce::ChildProcessManager::createAndStartManagedChildProcess | ( | Args &&... | args | ) |
| inline

Creates a new ChildProcess and starts it with the provided arguments.

The arguments are the same as the overloads to ChildProcess::start().

The manager will keep the returned ChildProcess object alive until it terminates and its return value has been queried. Calling ChildProcess::kill() on the returned object will eventually cause its removal from the ChildProcessManager after it terminates.

Definition at line 63 of file juce_ChildProcessManager.h.

## ◆ hasRunningProcess()

auto juce::ChildProcessManager::hasRunningProcess | ( |  | ) | const
| inline

Returns true if the ChildProcessManager contains any running ChildProcesses that it's monitoring.

Definition at line 88 of file juce_ChildProcessManager.h.

The documentation for this class was generated from the following files:

- juce_ChildProcessManager.h
- juce_ChildProcessManager.cpp